Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #1563 (closed defect: duplicate)

Opened 12 years ago

Last modified 12 years ago

memory leak between 3 (and more?) ad-hoc

Reported by: J-Nox@kremenchug.net Assigned to:
Priority: minor Milestone: version 0.9.5
Component: madwifi: 802.11 stack Version:
Keywords: Cc:
Patch is attached: 0 Pending:

Description

I have found the problem:
All works well in ad-hoc mode - if a network only between two ad-hoc stations.
If to include the third ad-hoc station - there is an "memory leak" about 1-4kb/s

If third station is disconnected - memory leak is disappear

ath_rate_sample: 1.2 (svn r2568)
ath_pci: 0.9.4.5 (svn r2568)
ath_hal: 0.9.30.13 (AR5210, AR5211, AR5212, AR5416, RF5111, RF5112, RF2413, RF5413, RF2133, REGOPS_FUNC)
wlan: 0.8.4.2 (svn r2568)

platform xscale arm ixp4xx big endian
kernel Linux OpenWrt 2.6.21.6 armv5teb

Change History

10/26/07 19:18:11 changed by anonymous

It looks like there's a node leak when receiving management frames in adhoc mode.
Here's the the commonly occurring leak as reported by kmemleak:

orphan pointer 0xc177ab34 (size 768):
  c007f7dc: <__kmalloc>
  bf07b934: <ath_node_alloc>
  bf04ca84: <ieee80211_alloc_node>
  bf04cb78: <ieee80211_alloc_node_table>
  bf04d210: <ieee80211_dup_bss>
  bf04da58: <ieee80211_fakeup_adhoc_node>
  bf04813c: <ieee80211_recv_mgmt>
  bf07c394: <ath_recv_mgmt>
  bf04ac54: <ieee80211_input>
  bf04bc80: <ieee80211_input_all>
  bf084514: <ath_rx_tasklet>
  c0049d28: <tasklet_action>
  c004988c: <__do_softirq2>
  c004993c: <__do_softirq>
  c0049a78: <irq_exit>
  c0027e28: <asm_do_IRQ>
  c00269e0: <__irq_svc>
  c0028754: <cpu_idle>
  c0026020: <__init_end>
  c0008800: <start_kernel>

After instrumenting the madwifi code to print out all allocs and deallocs, orphaned pointers matched the pointers that were alloced but not dealloced.

However, it appears that patch submitted in #1595 fixes the problem as kmemleak no longer reports orphaned pointers to nodes.

10/27/07 19:59:40 changed by mentor

  • status changed from new to closed.
  • component changed from madwifi: other to madwifi: 802.11 stack.
  • resolution set to duplicate.
  • milestone set to version 0.9.4.

#1595

thanks

02/11/08 06:22:50 changed by mrenzmann

  • milestone changed from version 0.9.4 to version 0.9.5.